<script setup lang="ts">
import { onMounted, reactive, watch } from 'vue'
import MemoryCard from '@/components/MemoryCard.vue'
import AppButton from '@/components/ui/AppButton.vue'
import { useAppStore } from '@/stores/app'

type CardMeta = {
  index: number
  turned: boolean
  done: boolean
  id: number
}

const fullTitle = 'Oh... mais je le connais ce con !'
let titleIndex = 0
let titleIntervalHandle = 0

const urls = [
  'https://directus.agepoly.ch/assets/2e94b90d-f782-41cd-8028-9ff876f7c3c3',
  'https://directus.agepoly.ch/assets/3b93e760-fbab-4035-8611-cd99139fcb68',
  'https://directus.agepoly.ch/assets/72c975de-952b-494c-b322-9e54953d9226',
  'https://directus.agepoly.ch/assets/6eca8f5d-4253-4fe8-a76e-be4f93e07c85',
  'https://directus.agepoly.ch/assets/4dd2d51b-4522-438c-9ea4-f8af9b2917dd',
  'https://directus.agepoly.ch/assets/5617c137-19de-480d-be4a-36aa033cf893',
  'https://directus.agepoly.ch/assets/4d6f63d4-b362-4c2d-99c6-7ec951700395'
]

const indices: number[] = []
for (let i = 0; i < urls.length; i++) {
  indices.push(i)
  indices.push(i)
}
for (let i = indices.length - 1; i > 0; i--) {
  let j = Math.floor(Math.random() * (i + 1))
  let temp = indices[i]
  indices[i] = indices[j]
  indices[j] = temp
}

const state = reactive({
  step: 0,
  title: '',
  firstCard: null as CardMeta | null,
  secondCard: null as CardMeta | null,
  cards: indices.map((i, j) => ({ turned: false, done: false, index: i, id: j })) as CardMeta[]
})

watch(state, () => {
  console.log(state.step)
})

onMounted(() => {
  setInterval(() => {
    titleIndex++
    state.title = fullTitle.substring(0, titleIndex)
    if (titleIndex === fullTitle.length) {
      setTimeout(() => {
        state.step = 1
        clearInterval(titleIntervalHandle)
        setTimeout(() => {
          state.step = 2
          setTimeout(() => {
            state.step = 3
          }, 3000)
        }, 3000)
      }, 1000)
    }
  }, 100)
})

function cardClicked(id: number) {
  if (state.secondCard != null) {
    return
  }
  const c = state.cards.find((c) => c.id === id)
  if (!c) {
    console.error('card not found: ', id)
    return
  }

  if (state.firstCard === null) {
    state.firstCard = c
  } else {
    state.secondCard = c
    if (state.firstCard!.index === state.secondCard!.index) {
      state.firstCard!.done = true
      state.secondCard!.done = true
      state.firstCard = null
      state.secondCard = null

      checkEnd()
    } else {
      setTimeout(() => {
        state.firstCard!.turned = false
        state.secondCard!.turned = false
        state.firstCard = null
        state.secondCard = null
      }, 3000)
    }
  }

  c.turned = true
}

function checkEnd() {
  const allDone = state.cards.filter((c) => !c.done).length === 0
  if (allDone) {
    state.step = 4
    setTimeout(() => {
      state.step = 5
      const app = useAppStore()
      localStorage.setItem('t', app.sessionKey ?? '')
    }, 1000)
  }
}
</script>

<template>
  <main id="main" class="flex justify-center items-center">
    <div class="relative p-4 w-full max-w-lg h-full md:h-auto">
      <AppCard v-if="state.step === 0">
        <div class="text-center">
          <h3 class="mb-5 text-2xl font-bold text-gray-900 dark:text-white">
            {{ state.title }}
          </h3>
        </div>
      </AppCard>

      <div
        v-if="state.step === 1 || state.step === 2"
        class="absolute z-10 top-1/2 left-1/2 -translate-x-1/2 -translate-y-1/2"
      >
        <img
          class="animate-banane"
          src="https://upload.wikimedia.org/wikipedia/commons/a/a8/Fr%C3%A9quence_banane.png"
        />
      </div>

      <AppCard v-if="state.step === 2 || state.step === 3">
        <div class="text-center">
          <h3 class="mb-5 text-2xl font-bold text-gray-900 dark:text-white">
            On va jouer à un petit jeu... ;)
          </h3>

          <div class="grid grid-cols-4 gap-4">
            <MemoryCard
              :index="card.index % urls.length"
              :url="urls[card.index % urls.length]"
              :turned="card.turned"
              :done="card.done"
              v-for="card in state.cards"
              v-bind:key="card.id"
              @click="() => cardClicked(card.id)"
            />
          </div>
        </div>
      </AppCard>

      <AppCard v-if="state.step === 4">
        <div class="text-center">
          <h3 class="mb-5 text-2xl font-bold text-gray-900 dark:text-white">Bravo Alex !!!!!</h3>

          <div class="max-w-xl">
            <img
              class="rounded-lg"
              src="https://directus.agepoly.ch/assets/56fbba1d-5ac3-4bc4-b677-8182de1b7057"
            />
          </div>
        </div>
      </AppCard>

      <AppCard v-if="state.step === 5">
        <div class="text-center">
          <h3 class="mb-5 text-2xl font-bold text-gray-900 dark:text-white">
            Oups... mais encore bravo !!!
          </h3>

          <div class="max-w-xl mb-5">
            <img
              class="rounded-lg"
              src="https://directus.agepoly.ch/assets/0dc23a49-306a-44cf-add9-7a84b964a8e1"
            />
          </div>

          <AppButton variant="outlined">Assez rigolé, back to Yearbook!</AppButton>
        </div>
      </AppCard>
    </div>
  </main>
</template>

<style scoped>
@keyframes banane {
  0% {
    transform: rotate(0deg) scale(0);
  }

  50% {
    transform: rotate(3600deg) scale(5);
  }

  100% {
    transform: rotate(0deg) scale(0);
  }
}
.animate-banane {
  animation: banane 6s ease-in-out;
}
</style>
